﻿''' <summary>
''' 指定されたコントロールで脱出ゲームを実行します。
''' </summary>
''' <remarks></remarks>
Public Class EscapeGame
    '矢印の大きさ
    Const ARROW_SIZE = 20.0F
    '矢印の振れ幅
    Const ARROW_RANGE = 5.0F
    '長方形の幅(.Widthではない)
    Const RECT_RANGE = 50I

    Public Sub New(ByVal target As Control)
        'Targetを設定
        Me.Target = target

        '最初の画面へ
        CurrentScene = SceneTitle
    End Sub

    ''' <summary>
    ''' シーンを初期化
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub InitializeScenes()
        '----------シーンの命名法----------
        'ここから下にはシーンを初期化するコードになっています。
        '作者の考えた基本的なシーンの命名法をここに記します。
        '
        '●シーン名は日本語にする(コメントを付けずに済み、英語のスペルミスが発生しない)
        '●シーン名にはそのシーンの種別を表す略語を付ける。

        '　未…まだアイテムをとっていない状態
        '　済…アイテムを既に取った状態
        '　開…ドアやふたが開いている状態
        '　閉…ドアやふたが閉まっている状態
        '　押…ボタンが押されている状態
        '--------------終わり--------------

        '絶対URL
        Const BASE_URL = "http://brv314.web.fc2.com/private/esc_1/"
        'Const BASE_URL = "C:\Users\brv\Pictures\Esc_1\"

        Dim 東 = GameScene.Instance
        With 東
            .Directions.Add(Direction.Left, GameCommand.北)
            .Directions.Add(Direction.Right, GameCommand.南)
            .Image = ImageFromWeb(BASE_URL & "east.jpg")
            .Rectangles.Add(New Rectangle(62, 304, 125, 126), GameCommand.林箱)
            .Rectangles.Add(New Rectangle(325, 323, 149, 118), GameCommand.テーブル)
        End With
        Scenes.Add(GameCommand.東, 東)

        Dim 西 = GameScene.Instance
        With 西
            .Directions.Add(Direction.Left, GameCommand.南)
            .Directions.Add(Direction.Right, GameCommand.北)
            .Image = ImageFromWeb(BASE_URL & "west.jpg")
            .Rectangles.Add(New Rectangle(195, 132, 207, 165), GameCommand.山絵)
            .LaserPoint1 = New Point(292, 221)
            .LaserPoint2 = New Point(-10, 334)
        End With
        Scenes.Add(GameCommand.西, 西)

        Dim 南 = GameScene.Instance
        With 南
            .Directions.Add(Direction.Left, GameCommand.東)
            .Directions.Add(Direction.Right, GameCommand.西)
            .Image = ImageFromWeb(BASE_URL & "south.jpg")
            .Rectangles.Add(New Rectangle(535, 151, 67, 197), GameCommand.風林火山)
            .LaserPoint1 = New Point(810, 234)
            .LaserPoint2 = New Point(355, 319)
        End With
        Scenes.Add(GameCommand.南, 南)

        Dim 北閉 = GameScene.Instance
        With 北閉
            .Directions.Add(Direction.Left, GameCommand.西)
            .Directions.Add(Direction.Right, GameCommand.東)
            .Image = ImageFromWeb(BASE_URL & "northc.jpg")
            .Rectangles.Add(New Rectangle(613, 304, 125, 135), GameCommand.林箱)
            .Rectangles.Add(New Rectangle(105, 207, 66, 51), GameCommand.風パネル)
        End With
        Scenes.Add(GameCommand.北閉, 北閉)

        Dim 北開 = GameScene.Instance
        With 北開
            .Directions.Add(Direction.Left, GameCommand.西)
            .Directions.Add(Direction.Right, GameCommand.東)
            .Image = ImageFromWeb(BASE_URL & "northo.jpg")
            .Rectangles.Add(New Rectangle(613, 304, 125, 135), GameCommand.林箱)
            .Rectangles.Add(New Rectangle(105, 207, 66, 51), GameCommand.風パネル)
            .Rectangles.Add(New Rectangle(326, 127, 148, 285), GameCommand.ドア)
        End With
        Scenes.Add(GameCommand.北開, 北開)

        Dim 風パネル = GameScene.Instance
        With 風パネル
            .Directions.Add(Direction.Down, GameCommand.北)
            .Image = ImageFromWeb(BASE_URL & "wind.jpg")
            .Rectangles.Add(New Rectangle(334, 259, 65, 73), GameCommand.風パネル押)
        End With
        Scenes.Add(GameCommand.風パネル, 風パネル)

        Dim 林箱 = GameScene.Instance
        With 林箱
            .Directions.Add(Direction.Down, GameCommand.北)
            .Image = ImageFromWeb(BASE_URL & "woods.jpg")
            .Rectangles.Add(New Rectangle(350, 189, 108, 87), GameCommand.林箱押)
        End With
        Scenes.Add(GameCommand.林箱, 林箱)

        Dim 山絵 = GameScene.Instance
        With 山絵
            .Directions.Add(Direction.Down, GameCommand.西)
            .Image = ImageFromWeb(BASE_URL & "mountpict.jpg")
            .LaserPoint1 = New Point(376, 292)
            .LaserPoint2 = New Point(-10, 396)
            .Rectangles.Add(New Rectangle(264, 191, 232, 184), GameCommand.山絵押)
        End With
        Scenes.Add(GameCommand.山絵, 山絵)

        Dim 風林火山 = GameScene.Instance
        With 風林火山
            .Directions.Add(Direction.Down, GameCommand.南)
            .Image = ImageFromWeb(BASE_URL & "kakejiku.jpg")
        End With
        Scenes.Add(GameCommand.風林火山, 風林火山)

        Dim 山パネル = GameScene.Instance
        With 山パネル
            .Directions.Add(Direction.Down, GameCommand.南)
            .Image = ImageFromWeb(BASE_URL & "mountbutton.jpg")
            .Rectangles.Add(New Rectangle(301, 180, 191, 190), GameCommand.山パネル押)
        End With
        Scenes.Add(GameCommand.山パネル, 山パネル)

        Dim テーブル = GameScene.Instance
        With テーブル
            .Directions.Add(Direction.Down, GameCommand.東)
            .Image = ImageFromWeb(BASE_URL & "table.jpg")
            .Rectangles.Add(New Rectangle(265, 410, 293, 109), GameCommand.テーブル下)
            .Rectangles.Add(New Rectangle(329, 118, 261, 130), GameCommand.テーブル後)
        End With
        Scenes.Add(GameCommand.テーブル, テーブル)

        Dim テーブル下 = GameScene.Instance
        With テーブル下
            .Directions.Add(Direction.Down, GameCommand.テーブル)
            .Image = ImageFromWeb(BASE_URL & "under.jpg")
            .Rectangles.Add(New Rectangle(465, 326, 172, 102), GameCommand.紙)
        End With
        Scenes.Add(GameCommand.テーブル下, テーブル下)

        Dim テーブル後 = GameScene.Instance
        With テーブル後
            .Directions.Add(Direction.Down, GameCommand.テーブル)
            .Image = ImageFromWeb(BASE_URL & "behind.jpg")
            .Rectangles.Add(New Rectangle(398, 374, 37, 41), GameCommand.テーブル後押)
        End With
        Scenes.Add(GameCommand.テーブル後, テーブル後)

        Dim 紙 = GameScene.Instance
        With 紙
            .Directions.Add(Direction.Down, GameCommand.テーブル)
            .Image = ImageFromWeb(BASE_URL & "paper.jpg")
            .Rectangles.Add(New Rectangle(53, 44, 685, 507), GameCommand.テーブル下)
        End With
        Scenes.Add(GameCommand.紙, 紙)

        Dim ドア = GameScene.Instance
        With ドア
            .Directions.Add(Direction.Down, GameCommand.北)
            .Image = ImageFromWeb(BASE_URL & "door.jpg")
            .Rectangles.Add(New Rectangle(317, 87, 155, 282), GameCommand.終了)
        End With
        Scenes.Add(GameCommand.ドア, ドア)

        Dim 終了 = SceneEnding
        Scenes.Add(GameCommand.終了, 終了)
    End Sub

    Private Sub RecognizeCommand(ByVal command As GameCommand)
        Select Case command
            Case GameCommand.開始
                '開始の効果音
                PlaySE(My.Resources.ButtonStart, True)
                '待機
                Target.Cursor = Cursors.WaitCursor
                'Scenesの初期化
                InitializeScenes()
                'デフォルトのカーソル
                Target.Cursor = Cursors.Default
                'シーン「北」へ
                ExecuteCommand(GameCommand.北)
            Case GameCommand.北
                If Parameters.ドア開 = True Then
                    'ドアが開いている
                    CurrentScene = Scenes(GameCommand.北開)
                Else
                    'ドアが閉まっている
                    If Parameters.開始 = False Then
                        Parameters.開始 = True
                        PlaySE(My.Resources.TitleJingle)
                    End If
                    CurrentScene = Scenes(GameCommand.北閉)
                End If

            Case GameCommand.林箱押
                PlaySE(My.Resources.Button2)
                If Parameters.風林火山 = 1 Then
                    Parameters.風林火山 = 2
                Else
                    Parameters.風林火山 = 0
                End If

            Case GameCommand.山パネル押
                If Parameters.風林火山 = 3 Then
                    PlaySE(My.Resources.Button1, True)
                    PlaySE(My.Resources.Door, True)
                    Parameters.ドア開 = True
                Else
                    PlaySE(My.Resources.Button1)
                    Parameters.風林火山 = 0
                End If

            Case GameCommand.紙
                PlaySE(My.Resources.Paper)

            Case GameCommand.テーブル後押
                PlaySE(My.Resources.Button1)
                If Parameters.風林火山 = 2 Then
                    Parameters.風林火山 = 3
                Else
                    Parameters.風林火山 = 0
                End If

            Case GameCommand.風パネル押
                PlaySE(My.Resources.Button2, True)
                PlaySE(My.Resources.Wind)
                Select Case Parameters.風林火山
                    Case 0, 1
                        Parameters.風林火山 = 1
                    Case Else
                        Parameters.風林火山 = 0
                End Select

            Case GameCommand.山絵押
                If Parameters.レーザー = False Then
                    PlaySE(My.Resources.Laser)
                    Dim 山絵 = Scenes(GameCommand.山絵)
                    Dim 西 = Scenes(GameCommand.西)
                    Dim 南 = Scenes(GameCommand.南)
                    山絵.LaserOn = True
                    西.LaserOn = True
                    南.LaserOn = True
                    南.Rectangles.Add(New Rectangle(341, 315, 30, 20), GameCommand.山パネル)
                    Scenes(GameCommand.山絵) = 山絵
                    Scenes(GameCommand.西) = 西
                    Scenes(GameCommand.南) = 南
                    Parameters.レーザー = True
                    'TODO:なぜかレーザーが描画されない
                End If
            Case GameCommand.終了
                PlaySE(My.Resources.EndingJingle)
                Clear = True
        End Select
    End Sub

    ''' <summary>
    ''' コマンドを実行
    ''' </summary>
    ''' <param name="command">実行するコマンド</param>
    ''' <remarks></remarks>
    Private Sub ExecuteCommand(ByVal command As GameCommand)
        'コマンドが無効
        If command = GameCommand.無効 Then
            Return
        End If

        Try
            'コマンドに合うシーンがあるか(あればそのシーンへジャンプ)
            CurrentScene = Scenes(command)
        Catch ex As KeyNotFoundException

        End Try
        'コマンドで場合分け
        RecognizeCommand(command)
    End Sub

    Private Sub DrawScreen(ByVal g As Graphics)
        '画面のイメージ
        Dim bmp = New Bitmap(SCREEN_WIDTH, SCREEN_HEIGHT)
        'bmp の Graphics
        Dim g2 = Graphics.FromImage(bmp)

        '現在のシーンのイメージを描画
        g2.DrawImage(CurrentScene.Image, g2.VisibleClipBounds)
        'レーザーを描画
        If CurrentScene.LaserOn Then
            g2.DrawLine(New Pen(Color.FromArgb(128, Color.Red), 5), _
                        CurrentScene.LaserPoint1, CurrentScene.LaserPoint2)
            g2.DrawLine(Pens.White, CurrentScene.LaserPoint1, CurrentScene.LaserPoint2)
        End If
        '矢印を描画
        For dir As Direction = Direction.Left To Direction.Down
            Dim arrow As Point() = GetArrow(dir)
            If CurrentScene.Directions.Keys.Contains(dir) AndAlso _
            GetDirRect(dir).Contains(Me.CursorPos) Then
                g2.FillPolygon(Brushes.Orange, arrow)
                g2.DrawPolygon(New Pen(Color.Gray, 3), arrow)
            End If
        Next
        '------------------------------TEST CODE------------------------------
        'For Each rect As Rectangle In CurrentScene.Rectangles.Keys
        '    g2.DrawRectangle(Pens.Red, rect)
        'Next
        '---------------------------------END---------------------------------
        'Targetに、完成したイメージを描画
        g.DrawImage(bmp, New Point(0, 0))
    End Sub

    Private ReadOnly Property SceneTitle() As GameScene
        Get
            Dim gs = GameScene.Instance
            gs.Image = My.Resources.Title

            gs.Rectangles.Add(New Rectangle(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT), GameCommand.開始)
            Return gs
        End Get
    End Property

    Private ReadOnly Property SceneEnding() As GameScene
        Get
            Dim gs = GameScene.Instance
            gs.Image = My.Resources.Ending
            Return gs
        End Get
    End Property

    ''' <summary>
    ''' 効果音を再生
    ''' </summary>
    ''' <param name="stream"></param>
    ''' <remarks></remarks>
    Private Sub PlaySE(ByVal stream As IO.Stream, Optional ByVal sync As Boolean = False)
        '前と同じ音かどうかを確かめるハッシュ値(0にしておくが、一致の危険性がある)
        Static backupHash As Integer = 0
        If stream.GetHashCode <> backupHash Then
            '前回と違う音
            PlayerSE = New Media.SoundPlayer(stream)
            backupHash = stream.GetHashCode
        End If
        '再生
        If sync Then
            PlayerSE.PlaySync()
        Else
            PlayerSE.Play()
        End If
    End Sub

#Region "基本メンバ(基本的に編集の必要がないメンバ)"
    'スクリーンの幅
    Private Const SCREEN_WIDTH As Integer = 800
    'スクリーンの高さ
    Private Const SCREEN_HEIGHT As Integer = 600
    'シーンを含むDictionary
    Private Scenes As New Dictionary(Of GameCommand, GameScene)
    '効果音のプレイヤー
    Private PlayerSE As Media.SoundPlayer
    '現在のシーン
    Private _CurrentScene As GameScene
    '描画のためのタイマー
    WithEvents DrawTimer As New Timer With {.Enabled = True, .Interval = 100}

    Private Property CurrentScene() As GameScene
        Get
            Return _CurrentScene
        End Get
        Set(ByVal value As GameScene)
            _CurrentScene = value
            '画面を更新
            Target.Invalidate()
        End Set
    End Property

    Private WithEvents _Target As Control
    ''' <summary>
    ''' 描画のターゲット
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Target() As Control
        Get
            Return _Target
        End Get
        Set(ByVal value As Control)
            _Target = value
        End Set
    End Property

    'カーソルの位置
    Private _CursorPos As Point
    Public ReadOnly Property CursorPos() As Point
        Get
            Return _CursorPos
        End Get
    End Property

    Public ReadOnly Property Width() As Integer
        Get
            Return SCREEN_WIDTH
        End Get
    End Property

    Public ReadOnly Property Height() As Integer
        Get
            Return SCREEN_HEIGHT
        End Get
    End Property

    Public ReadOnly Property Size() As Size
        Get
            Return New Size(SCREEN_WIDTH, SCREEN_HEIGHT)
        End Get
    End Property


    ''' <summary>
    ''' クリックされた位置からコマンドを取得
    ''' </summary>
    ''' <param name="loc">クリックされた位置</param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function GetCommandFromLoc(ByVal loc As Point) As GameCommand
        '各方向の長方形をチェック
        For dir As Direction = Direction.Left To Direction.Down
            If GetDirRect(dir).Contains(loc) Then
                Try
                    Return CurrentScene.Directions(dir)
                Catch ex As Exception
                    Return GameCommand.無効
                End Try
            End If
        Next

        '各長方形をチェック
        For Each rect As Rectangle In CurrentScene.Rectangles.Keys
            If rect.Contains(loc) Then
                Return CurrentScene.Rectangles(rect)
            End If
        Next
        Return GameCommand.無効
    End Function

    Private Function ImageFromWeb(ByVal url As String) As Image
        Dim wc As New Net.WebClient
        Dim st As IO.Stream = wc.OpenRead(url)
        Return Image.FromStream(st)
    End Function

    ''' <summary>
    ''' 各方向の長方形を初期化
    ''' </summary>
    ''' <remarks></remarks>
    Private Function GetDirRect(ByVal dir As Direction) As Rectangle

        '各方向の長方形
        Select Case dir
            Case Direction.Left
                Return New Rectangle(0, RECT_RANGE, RECT_RANGE, SCREEN_HEIGHT - 2 * RECT_RANGE)
            Case Direction.Up
                Return New Rectangle(RECT_RANGE, 0, SCREEN_WIDTH - 2 * RECT_RANGE, RECT_RANGE)
            Case Direction.Right
                Return New Rectangle(SCREEN_WIDTH - RECT_RANGE, RECT_RANGE, RECT_RANGE, SCREEN_HEIGHT - 2 * RECT_RANGE)
            Case Direction.Down
                Return New Rectangle(RECT_RANGE, SCREEN_HEIGHT - RECT_RANGE, SCREEN_WIDTH - 2 * RECT_RANGE, RECT_RANGE)
            Case Else
                Return Nothing
        End Select
    End Function

    Private Function GetArrow(ByVal dir As Direction) As Point()
        '長方形の中心
        Dim rectCenter As Point
        With GetDirRect(dir)
            rectCenter = New Point(.X + .Width / 2, .Y + .Height / 2)
        End With
        Select Case dir
            Case Direction.Left
                rectCenter = New Point(rectCenter.X + ARROW_RANGE * TimerCount Mod 2, rectCenter.Y)
                Return New Point() { _
                       New Point(rectCenter.X - ARROW_SIZE / 2, rectCenter.Y), _
                       New Point(rectCenter.X + ARROW_SIZE / 2, rectCenter.Y + ARROW_SIZE), _
                       New Point(rectCenter.X + ARROW_SIZE / 2, rectCenter.Y - ARROW_SIZE) _
                       }
            Case Direction.Up
                rectCenter = New Point(rectCenter.X, rectCenter.Y + ARROW_RANGE * TimerCount Mod 2)
                Return New Point() { _
                       New Point(rectCenter.X, rectCenter.Y - ARROW_SIZE / 2), _
                       New Point(rectCenter.X - ARROW_SIZE, rectCenter.Y + ARROW_SIZE / 2), _
                       New Point(rectCenter.X + ARROW_SIZE, rectCenter.Y + ARROW_SIZE / 2) _
                       }
            Case Direction.Right
                rectCenter = New Point(rectCenter.X + ARROW_RANGE * TimerCount Mod 2, rectCenter.Y)
                Return New Point() { _
                       New Point(rectCenter.X + ARROW_SIZE / 2, rectCenter.Y), _
                       New Point(rectCenter.X - ARROW_SIZE / 2, rectCenter.Y + ARROW_SIZE), _
                       New Point(rectCenter.X - ARROW_SIZE / 2, rectCenter.Y - ARROW_SIZE) _
                       }
            Case Direction.Down
                rectCenter = New Point(rectCenter.X, rectCenter.Y + ARROW_RANGE * TimerCount Mod 2)
                Return New Point() { _
                       New Point(rectCenter.X, rectCenter.Y + ARROW_SIZE / 2), _
                       New Point(rectCenter.X - ARROW_SIZE, rectCenter.Y - ARROW_SIZE / 2), _
                       New Point(rectCenter.X + ARROW_SIZE, rectCenter.Y - ARROW_SIZE / 2) _
                       }
            Case Else
                Return Nothing
        End Select
    End Function

    Private TimerCount = 0UL
    Private Sub DrawTimer_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles DrawTimer.Tick
        TimerCount += 1
        Target.Invalidate()
    End Sub

    Public Clear = False
#End Region

#Region "Targetのイベント処理関係"
    Private Sub Target_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles _Target.MouseDown
        'クリックされた長方形のコマンド
        Dim rectCommand As GameCommand = GetCommandFromLoc(e.Location)
        'コマンドを実行
        ExecuteCommand(rectCommand)
    End Sub

    Private Sub Target_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles _Target.MouseMove
        _CursorPos = e.Location
        Target.Invalidate()
    End Sub

    Private Sub Target_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles _Target.Paint
        DrawScreen(e.Graphics)
    End Sub
#End Region
End Class

''' <summary>
''' 方向を表す列挙体
''' </summary>
''' <remarks>実際の値はKeysの矢印キーの値に対応させています。</remarks>
Public Enum Direction
    Left = 37
    Up = 38
    Right = 39
    Down = 40
End Enum

